var ContextTypes, LoadQueueLoader, LoaderMixin, PropTypes, React, Status, img, span, _ref,
  __slice = [].slice;

React = require('react');

LoaderMixin = require('react-loadermixin');

PropTypes = React.PropTypes;

_ref = React.DOM, span = _ref.span, img = _ref.img;

Status = {
  PENDING: 'pending',
  LOADING: 'loading',
  LOADED: 'loaded',
  FAILED: 'failed'
};

ContextTypes = {
  loadQueue: function(props, propName, componentName) {
    var loadQueue;
    loadQueue = props[propName];
    if ((loadQueue != null) && typeof loadQueue['enqueue'] !== 'function') {
      console.warn("Context `" + propName + "` must have an `enqueue` method for `" + componentName + "`");
      return false;
    }
    return true;
  }
};

module.exports = LoadQueueLoader = React.createClass({
  displayName: 'LoadQueueLoader',
  mixins: [LoaderMixin],
  propTypes: {
    loader: PropTypes.func.isRequired,
    priority: PropTypes.number
  },
  contextTypes: {
    loadQueue: ContextTypes.loadQueue
  },
  getInitialState: function() {
    return {
      status: Status.PENDING
    };
  },
  getDefaultProps: function() {
    return {
      priority: 0
    };
  },
  componentDidMount: function() {
    if (this.state.status !== Status.PENDING) {
      return;
    }
    if (this.props.src != null) {
      return this.enqueueLoad(this.props.src, this.props.priority);
    }
  },
  componentWillUnmount: function() {
    var _ref1;
    return (_ref1 = this.state.loadResult) != null ? typeof _ref1.cancel === "function" ? _ref1.cancel() : void 0 : void 0;
  },
  componentWillReceiveProps: function(nextProps) {
    var _ref1, _ref2;
    if (nextProps.src !== this.props.src) {
      if ((_ref1 = this.state.loadResult) != null) {
        if (typeof _ref1.cancel === "function") {
          _ref1.cancel();
        }
      }
      return this.enqueueLoad(nextProps.src, nextProps.priority);
    } else if (nextProps.priority !== this.props.priority) {
      return (_ref2 = this.state.loadResult) != null ? _ref2.priority(nextProps.priority) : void 0;
    }
  },
  enqueueLoad: function(src, priority) {
    var loadResult, loader, _ref1;
    if (((_ref1 = this.context) != null ? _ref1.loadQueue : void 0) != null) {
      loader = (function(_this) {
        return function(callback) {
          if (!_this.isMounted()) {
            return;
          }
          return _this.setState({
            status: Status.LOADING,
            load: {
              src: src,
              callback: callback
            }
          });
        };
      })(this);
      loadResult = this.context.loadQueue.enqueue(loader, {
        priority: priority
      });
      return this.setState({
        loadResult: loadResult
      });
    } else {
      return this.setState({
        status: Status.LOADING,
        load: {
          src: src
        }
      });
    }
  },
  loaderDidLoad: function() {
    var args, _base;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    if (typeof (_base = this.state.load).callback === "function") {
      _base.callback.apply(_base, [null].concat(__slice.call(args)));
    }
    if (!this.isMounted()) {
      return;
    }
    return this.setState({
      status: Status.LOADED
    });
  },
  loaderDidError: function() {
    var args, _base;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    if (typeof (_base = this.state.load).callback === "function") {
      _base.callback.apply(_base, args);
    }
    if (!this.isMounted()) {
      return;
    }
    return this.setState({
      status: Status.FAILED
    });
  },
  render: function() {
    if (!this.context.loadQueue || (this.state.load != null)) {
      return this.renderLoader(this.props.loader);
    } else {
      return this.props.loader();
    }
  }
});
